#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#ifdef HAVE_GL_GL_H
#  include <GL/gl.h>
#elif HAVE_OPENGL_GL_H
#  include <OpenGL/gl.h>
#endif
#ifdef HAVE_GL_GLU_H
#  include <GL/glu.h>
#elif HAVE_OPENGL_GLU_H
#  include <OpenGL/glu.h>
#endif
#include <SDL.h>
#include "events.h"
#include "globals.h"
#include "height_quantity.h"

int AnugaVis_Step(void){
  SDL_Event event;
  int more = 1;
  struct height_quantity_simple *height;

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(anugavis.eye[0], anugavis.eye[1], anugavis.eye[2],
	    anugavis.focus[0], anugavis.focus[1], anugavis.focus[2],
	    0, 0, 1);
  for(height = anugavis.heights ; height != NULL ; height = height->next)
    AnugaVis_DrawHeightQuantity(height);
  SDL_GL_SwapBuffers();
  /* TODO: Add support for moving the camera. */
  while(SDL_PollEvent(&event))
    switch(event.type){
    case SDL_KEYDOWN:
      switch(event.key.keysym.sym){
      case SDLK_ESCAPE:
	more = 0;
	break;
      default:
	break;
      }
      break;
    case SDL_KEYUP:
      switch(event.key.keysym.sym){
      default:
	break;
      }
      break;
    }
  return more;
}

void AnugaVis_Run(void){
  while(AnugaVis_Step());
}
